<?php

namespace App\Services\Customer;

use App\DTOs\Customer\ClientDTO;
use App\Entities\Customer\ClientEntity;
use App\Entities\PaymentEntity;
use App\Forms\Customer\ClientForm;
use App\Helpers\Customer\ClientHelper;
use App\Models\Customer\ClientModel;
use RuntimeException;

class ClientService extends CustomerService
{
    private $_form = null;
    private $_helper = null;
    public function __construct(ClientModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('Client');
    }
    public function getDTOClass(): string
    {
        return ClientDTO::class;
    }
    public function createDTO(array $formDatas): ClientDTO
    {
        return new ClientDTO($formDatas);
    }
    public function getEntityClass(): string
    {
        return ClientEntity::class;
    }
    public function getFormService(): ClientForm
    {
        if ($this->_form === null) {
            $this->_form = new ClientForm();
            $this->_form->setAttributes([
                'pk_field'         =>  $this->getPKField(),
                'title_field'      => $this->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_form;
    }
    public function getHelper(): ClientHelper
    {
        if ($this->_helper === null) {
            $this->_helper = new ClientHelper();
            $this->_helper->setAttributes([
                'pk_field'         =>  $this->getPKField(),
                'title_field'      => $this->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_helper;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): ClientEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    public function setSearchWord(string $word): void
    {
        $this->model->orLike($this->model->getTable() . '.alias', $word, 'both');
        parent::setSearchWord($word);
    }
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy("site ASC,name ASC");
        parent::setOrderBy($field, $value);
    }
}
